{-
  Formalization of some category theory
  (in dire need of implicit arguments!)
-}

-- # import Prop

Obj : Set
Hom : Obj -> Obj -> Set

id : (A:Obj) -> Hom A A
comp : (A:Obj) -> (B:Obj) -> (C:Obj) ->
	Hom A B -> Hom B C -> Hom A C

axId1 : (A:Obj) -> (B:Obj) ->
	 (f:Hom A B) ->
	 Eq (Hom A B) f (comp A A B (id A) f)

axId2 : (A:Obj) -> (B:Obj) ->
	 (f:Hom A B) ->
	 Eq (Hom A B) f (comp A B B f (id B))

assoc : (A:Obj) -> (B:Obj) -> (C:Obj) -> (D:Obj) -> 
         (f:Hom A B) -> (g:Hom B C) -> (h:Hom C D) ->
         Eq (Hom A D) (comp A C D (comp A B C f g) h)
		      (comp A B D f (comp B C D g h))

-- A morphism f is mono iff
-- forall i and j
--   i.f == j.f  ==>  i == j

isMonoDef : (A:Obj) -> (B:Obj) -> Hom A B -> Prop
isMonoDef A B f = 
    (C:Obj) -> (i:Hom C A) -> (j:Hom C A) -> 
    Eq (Hom C B) (comp C A B i f) (comp C A B j f) ->
    Eq (Hom C A) i j

isMono : (A:Obj) -> (B:Obj) -> Hom A B -> Prop

elimMono : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> 
            isMono A B f -> isMonoDef A B f

introMono : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> 
	     isMonoDef A B f -> isMono A B f

-- Example:: if f.g is mono then f is mono

A:Obj
B:Obj
C:Obj
f:Hom A B
g:Hom B C

fg = comp A B C f g

prop : isMono A C fg -> isMonoDef A B f
prop = fol-plugin(assoc,elimMono)

{-
We would like to say

prop : isMono A C fg -> isMono A B f
prop = fol-plugin(assoc,elimMono,introMono)

but gandalf isn't clever enough.
-}
