
-- # import Property

data Nat : Set where
  Z : Nat
  S : Nat -> Nat

(+) : Nat -> Nat -> Nat
x + Z = x
x + (S y) = S (x + y)

natInd : (P : Nat -> Prop) ->
	  P Z ->
	  ((n : Nat) -> P n -> P (S n)) ->
	  (n : Nat) ->
	  P n
natInd P pZ pS Z = pZ
natInd P pZ pS (S n) = pS n (natInd P pZ pS n)

infix 5 ==
(==) = Eq Nat

-- 0 + n == n
PlusZero : (n : Nat) -> Prop
PlusZero n = Z + n == n

plus_zero = natInd PlusZero fol-plugin((+)) fol-plugin((+))

-- S n + m == S (n + m)
PlusSucc : (n : Nat) -> Prop
PlusSucc n = (m : Nat) -> S m + n == S (m + n)

plus_succ = natInd PlusSucc fol-plugin((+)) fol-plugin((+))


-- n + m == m + n
PlusCommute : (n : Nat) -> Prop
PlusCommute n = (m : Nat) -> n + m == m + n

plus_commute = natInd PlusCommute
		      fol-plugin(plus_zero, (+))
		      fol-plugin(plus_succ, (+))

