
-- # import QuickCheck
-- # import Nat
-- # import Bool
-- # import Bool.Proofs
-- # import List

-- Helpers
ordered : List Nat -> Bool
ordered []	  = true
ordered [x]	  = true
ordered (x::y::xs)  = x <= y && ordered (y::xs)

-- Ordered lists
orderedGen : Gen (List Nat)
orderedGen = liftM  Gen monadGen
		    (List Nat) (List Nat)
		    (scanl1 Nat (+)) (arbList Nat arbNat)

-- Properties

-- A false property
PropMapOrdered : Type
PropMapOrdered =
    (f : Nat -> Nat) ->
      forAll (List Nat) orderedGen (\xs ->
	Holds (ordered (map Nat Nat f xs))
      )

--testMapOrdered : PropMapOrdered
--testMapOrdered = qc-plugin(arbFun Nat Nat (coarbNat Nat) arbNat)

PropMapLength : Prop
PropMapLength =
    (f : Nat -> Nat) ->
    (xs : List Nat) ->
      (Eq Nat (length Nat (map Nat Nat f xs)) (length Nat xs))

testMapLength : PropMapLength
testMapLength = qc-plugin ( arbFun Nat Nat (coarbNat Nat) arbNat
			  , arbList Nat arbNat
			  )

